#ifndef PLUGINMANAGER_H
#define PLUGINMANAGER_H

#include "fly-admin-printer_export.h"
#include <QList>
#include <QMap>
#include <QWidget>

class SecurityPlugin;
class SecurityPropertyTab;
class SecurityPropertyConfigTab;
class SecurityJobAction;

class FLY_ADMIN_PRINTER_EXPORT PluginManager
{
public:
    static PluginManager* instance();

    QList<SecurityPropertyTab *> createPropertyTabs(QWidget *parent = nullptr);
    QList<SecurityPropertyConfigTab *> createPropertyConfigTabs(QWidget *parent = nullptr);
    QList<SecurityJobAction *> createJobActions(QWidget *parent = nullptr);
    QMap<QString, QString> directivies() const; //name, description

private:
    PluginManager();
    ~PluginManager(){};
    static void destroy();

    QList<SecurityPlugin*> m_plugins;
    static PluginManager *m_instance;
};

#endif // PLUGINMANAGER_H
